/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2007
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.10 [6 Mar. 2007]
**
**  Device :	uPD78F0533_64
**
**  Compiler :	CC78K0
**
**  Creation date:	2007/04/08
**  
*******************************************************************************
*/

/*
*******************************************************************************
** Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "System.h"
#include "Port.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/
unsigned int	khz_no;
unsigned int	out_volt_data;
unsigned int	test_tun_data;
unsigned int	preset_data[35];
unsigned char	preset_no;

void	init_data(void)
{
	khz_no=58;
	out_volt_data=0;
}

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}
void	preset_set(void)
{
	preset_data[0]=62;preset_data[1]=63;preset_data[2]=66;preset_data[3]=74;preset_data[4]=77;
	preset_data[5]=83;preset_data[6]=86;preset_data[7]=90;preset_data[8]=92;preset_data[9]=106;
	preset_data[10]=112;preset_data[11]=114;preset_data[12]=117;preset_data[13]=126;preset_data[14]=131;
	preset_data[15]=138;preset_data[16]=140;preset_data[17]=142;preset_data[18]=143;preset_data[19]=146;
	preset_data[20]=148;preset_data[21]=150;preset_data[22]=157;preset_data[23]=158;preset_data[24]=160;
	preset_data[25]=168;preset_data[26]=173;preset_data[27]=134;preset_data[28]=130;preset_data[29]=121;
	preset_data[30]=108;preset_data[31]=82;preset_data[32]=80;preset_data[33]=79;preset_data[34]=97;

}
/*----------  LCD MODULE ----------*/
void	lcd_db(unsigned char data)
{
	P2.0=data&0x01;
	P2.1=(data&0x02)>>1;
	P2.2=(data&0x04)>>2;
	P2.3=(data&0x08)>>3;
}
void	lcd_wait(void)
{
	wait_time(5000);
}
void	lcd_c_set(void)
{
	P14.1=0;
	P14.0=1;
	wait_time(10);
	P14.0=0;
}
void	lcd_d_set(void)
{
	P14.1=1;
	P14.0=1;
	wait_time(10);
	P14.0=0;
}
void	lcd_cmd(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_c_set();
	lcd_db(data&0x0f);
	lcd_c_set();
	wait_time(500);
}
void	lcd_data(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_d_set();
	lcd_db(data&0x0f);
	lcd_d_set();
	wait_time(500);
}
void	lcd_init(void)
{
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(2);
	lcd_c_set();
	lcd_wait();
	
	lcd_cmd(0x28);
	lcd_cmd(0x08);
	lcd_cmd(0x0c);
	lcd_cmd(0x06);
}
void	lcd_clear(void)
{
	lcd_cmd(0x01);
}
void	lcd_xy(unsigned char x,unsigned char y)
{
unsigned char data;

	data=0x80;
	switch (y){
		case 0:data=0x80;break;
		case 1:data=0xc0;break;
		case 2:data=0x90;break;
		case 3:data=0xd0;break;
	}
	data=data+x;
	lcd_cmd(data);
}
void	lcd_print(char *data)
{
	while (*data!=0){
		lcd_data(*data++);
	}
}
void	lcd_su(unsigned char data)
{
	switch (data){
		case 0:lcd_print("0");break;
		case 1:lcd_print("1");break;
		case 2:lcd_print("2");break;
		case 3:lcd_print("3");break;
		case 4:lcd_print("4");break;
		case 5:lcd_print("5");break;
		case 6:lcd_print("6");break;
		case 7:lcd_print("7");break;
		case 8:lcd_print("8");break;
		case 9:lcd_print("9");break;
		case 10:lcd_print("A");break;
		case 11:lcd_print("B");break;
		case 12:lcd_print("C");break;
		case 13:lcd_print("D");break;
		case 14:lcd_print("E");break;
		case 15:lcd_print("F");break;
	}
}
void	lcd_khz(unsigned int hz)
{
unsigned char n0,n1,n2,n3;
unsigned int count;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);

	if(n3==0){lcd_print(" ");}else{lcd_su(n3);}
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
}
void	lcd_pr_byte(unsigned char data)
{
unsigned char data2;

	data2=data%16;data=data/16;
	lcd_su(data);
	lcd_su(data2);
}
void	lcd_ini_disp(void)
{
	lcd_xy(0,0);
	lcd_print("NEW");
	lcd_xy(0,1);
	lcd_print("AM");
	lcd_xy(5,0);
	lcd_print("SET=    kHz");
	lcd_xy(5,1);
	lcd_print("TUN=    kHz");

}
/*---------- VOLTAGE  ----------*/
void	vol_out(unsigned int volt)
{
unsigned int d0,d1,d2;

	d0=volt&0x0f;
	d1=(volt&0xf0)>>4;
	d2=(volt&0x300)>>8;
	P3=(unsigned char)d0;
	P4=(unsigned char)d1;
	P5=(unsigned char)d2;
}
void	volt_up(void)
{
	out_volt_data++;
	if(out_volt_data>=1024){
		out_volt_data=1023;
	}
}
void	volt_down(void)
{
	if(out_volt_data>0){
		out_volt_data--;
	}
}
void	vol_out_tun(unsigned int volt)
{
unsigned int d0,d1,d2;

	d0=(volt&0x0f)<<4;
	d1=volt&0xf0;
	d2=(volt&0x300)>>5;
	P1=(P1&0x0f)|(unsigned char)d0;
	P2=(P2&0x0f)|(unsigned char)d1;
	P12=(P12&0x07)|(unsigned char)d2;
}

/*----------  KHZ    ----------*/
void	khz_inc(void)
{
	khz_no++;
	if(khz_no==181){khz_no=58;}
}

void	khz_dec(void)
{
	khz_no--;
	if(khz_no==57){khz_no=180;}
}
void	khz_inc_10(void)
{
	khz_no=khz_no+10;
	if(khz_no>=181){khz_no=58;}
}

void	khz_dec_10(void)
{
	khz_no=khz_no-10;
	if(khz_no<=57){khz_no=180;}
}

void	khz_set(void)
{
unsigned long data;

	data=khz_no;
	data=(4336*data+168552)/1000;
	out_volt_data=(unsigned int)data;
}
void	khz_set_tun(void)
{
unsigned long data;

	data=khz_no;
	data=(474*data-3800)/100;
	vol_out_tun((unsigned int)data);
	/*--------------------
	lcd_xy(0,3);
	lcd_khz((unsigned int)data);
	test_tun_data=(unsigned int)data;
	----------------------*/
}
void	test_tun_up(void)
{
	test_tun_data++;
	vol_out_tun(test_tun_data);
}
void	test_tun_down(void)
{
	test_tun_data--;
	vol_out_tun(test_tun_data);
}
/*----------- DATA INPUT ----------*/
unsigned int freq_count_in(void)
{
unsigned int freq;
unsigned int d0,d1,d2,d3;

	d0=P7&0x0f;
	d1=(P7&0xf0)>>4;
	d2=P0&0x0f;
	d3=(P0&0x30)>>4;
	
	freq=d0+d1*10+d2*100+d3*1000;
	
	return freq;
}

/*----------- LED -----------*/
void	led_out(unsigned char nz)
{
	switch(nz){
		case 0:P12.0=1;P12.1=0;P12.2=1;break;
		case 1:P12.0=0;P12.1=1;P12.2=1;break;
		case 2:P12.0=1;P12.1=1;P12.2=0;break;
	}
}
/*---------- PRESET ---------*/
unsigned int preset_khz(unsigned char no)
{
	if(no>=35){no=34;}
	return preset_data[no];
}
void	preset_up(void)
{
	preset_no++;
	if(preset_no>=35){preset_no=0;}
}
void	preset_down(void)
{
	if(preset_no<=0){preset_no=34;}
	else{preset_no--;}
}
void	kyokumei(unsigned int no)
{
	lcd_xy(0,2);
	switch(no){
		case 62:lcd_print("RADIO KANSAI  20");break;
		case 63:lcd_print("NHK1 SAPPORO 100");break;
		case 66:lcd_print("NHK1 TOKYO   300");break;
		case 68:lcd_print("NHK1 FUKUOKA 100");break;
		case 69:lcd_print("NHK1            ");break;
		case 74:lcd_print("NHK1 OSAKA   100");break;
		case 77:lcd_print("NHK2 TOKYO   500");break;
		case 81:lcd_print("NHK1 NAGOYA   50");break;
		case 83:lcd_print("NHK2 SAPPORO 500");break;
		case 86:lcd_print("NHK2 AKITA   500");break;
		case 90:lcd_print("AFN  TOKYO    50");break;
		case 92:lcd_print("NHK2 OSAKA   300");break;
		case 93:lcd_print("NHK1            ");break;
		case 94:lcd_print("NHK1            ");break;
		case 96:lcd_print("FBC RADIO       ");break;
		case 97:lcd_print("NHK2 KUMAMOTO500");break;
		case 99:lcd_print("NHK1 SENDAI   20");break;
		case 103:lcd_print("NHK1           ");break;
		case 106:lcd_print("TBS RADIO    100");break;
		case 112:lcd_print("ABC RADIO     50");break;
		case 114:lcd_print("NHK1            ");break;
		case 117:lcd_print("CBC RADIO     50");break;
		case 121:lcd_print("NHK2 SENDAI   10");break;
		case 124:lcd_print("BSN RADIO      5");break;
		case 125:lcd_print("NHK2            ");break;
		case 126:lcd_print("BUNKA HOUSOU 100");break;
		case 127:lcd_print("KBS KYOTO     20");break;
		case 131:lcd_print("MBS RADIO     50");break;
		case 136:lcd_print("NHK1 KANAZAWA 10");break;
		case 138:lcd_print("NIPPON HOUSOU100");break;
		case 140:lcd_print("TBC RADIO     20");break;
		case 142:lcd_print("RKB RADIO     50");break;
		case 143:lcd_print("HBC RADIO     50");break;
		case 146:lcd_print("RADIO OSAKA   50");break;
		case 148:lcd_print("TOKAI RADIO   50");break;
		case 150:lcd_print("RCC RADIO     20");break;
		case 154:lcd_print("NHK2/NHK1       ");break;
		case 157:lcd_print("KBC RADIO     50");break;
		case 158:lcd_print("RADIO NIPPON  50");break;
		case 160:lcd_print("STV RADIO     50");break;
		case 168:lcd_print("NHK2            ");break;
		case 173:lcd_print("FBC RADIO       ");break;
		default:lcd_print("                ");break;
	}

	lcd_xy(0,3);
	switch(no){
		case 69:lcd_print("NKora/Russia/Chi");break;
		case 79:lcd_print("Korea           ");break;
		case 80:lcd_print("Russia/China    ");break;
		case 82:lcd_print("China/Korea/etc ");break;
		case 90:lcd_print("Korea/Russia    ");break;
		case 93:lcd_print("Korea           ");break;
		case 94:lcd_print("Korea           ");break;
		case 95:lcd_print("NKorea/China    ");break;
		case 97:lcd_print("China           ");break;
		case 99:lcd_print("Korea           ");break;
		case 108:lcd_print("Korea           ");break;
		case 110:lcd_print("Korea/China     ");break;
		case 116:lcd_print("China/Korea     ");break;
		case 117:lcd_print("NKorea          ");break;
		case 121:lcd_print("China           ");break;
		case 127:lcd_print("Korea           ");break;
		case 130:lcd_print("Korea           ");break;
		case 131:lcd_print("Korea           ");break;
		case 134:lcd_print("China           ");break;
		case 136:lcd_print("Russia          ");break;
		case 139:lcd_print("Russia/Korea    ");break;
		case 148:lcd_print("Korea           ");break;
		case 154:lcd_print("Korea           ");break;
		case 160:lcd_print("Korea           ");break;
		default:lcd_print("                ");break;
	}
}
/*---------- MAIN -----------*/
void  main( void )
{
unsigned int	freq_khz;
unsigned int	adj;
unsigned char	up_key;
unsigned char	up_rep;
unsigned char	up_cnt;
unsigned char	down_key;
unsigned char	down_rep;
unsigned char	down_cnt;
unsigned char	set_key;
unsigned char	set_rep;
unsigned char	menu_key;
unsigned char	menu_rep;

	init_data();
	preset_set();

	up_key=0;up_rep=0;
	down_key=0;down_rep=0;
	set_key=0;set_rep=0;
	menu_key=0;menu_rep=0;
	up_cnt=0;down_cnt=0;
	preset_no=0;

	lcd_init();
	lcd_clear();

	lcd_ini_disp();
	adj=0;

	khz_set();
	khz_set_tun();
	lcd_xy(9,0);
	lcd_khz(khz_no*9);

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */
		if (P1.0==0){
				up_key=0;
		}
		else{
			up_key=1;
			up_rep=0;
			up_cnt=0;
		}
		/*------------------*/
		if (P1.1==0){
				down_key=0;
		}
		else{
			down_key=1;
			down_rep=0;
			down_cnt=0;
		}
		/*------------------*/
		if (P1.2==0){
				set_key=0;
		}
		else{
			set_key=1;
			set_rep=0;
		}
		/*------------------*/
		if (P1.3==0){
				menu_key=0;
		}
		else{
			menu_key=1;
			menu_rep=0;
		}
		/*------------------*/


		/*-------------------*/
		
		lcd_xy(9,1);
		lcd_khz(freq_khz);
		/*lcd_xy(12,3);
		lcd_khz(out_volt_data);*/
		if(adj==0){
		/*---------------------*/
		freq_khz=freq_count_in();
		if(freq_khz==khz_no*9){
			adj=2000;
			led_out(0);
		}
		if(freq_khz==(khz_no*9+1)){
			volt_down();
			vol_out(out_volt_data);
			adj=500;
			led_out(0);
		}
		if(freq_khz==(khz_no*9-1)){
			volt_up();
			vol_out(out_volt_data);
			adj=500;
			led_out(0);
		}
		if(freq_khz>(khz_no*9+1)){
			volt_down();
			vol_out(out_volt_data);
			led_out(1);
		}
		if(freq_khz<(khz_no*9-1)){
			volt_up();
			vol_out(out_volt_data);
			led_out(2);
		}
		/*-----------------------*/
		}
		else{
			adj--;
		}
		/*-------------------*/

	/* key scan 2 */
		if ((P1.0==0)&(up_key==0)){
			up_key=0;
		}
		else{
			up_key=1;
			up_rep=0;
			up_cnt=0;
		}
		/*------------------*/
		if ((P1.1==0)&(down_key==0)){
			down_key=0;
		}
		else{
			down_key=1;
			down_rep=0;
			down_cnt=0;
		}
		/*------------------*/
		if ((P1.2==0)&(set_key==0)){
			set_key=0;
		}
		else{
			set_key=1;
			set_rep=0;
		}
		/*------------------*/
		if ((P1.3==0)&(menu_key==0)){
			menu_key=0;
		}
		else{
			menu_key=1;
			menu_rep=0;
		}
		/*------------------*/


	/* key action */
	
		if((up_key==0)&(up_rep==0)){
			up_rep=1;
			khz_inc();
			khz_set();
			khz_set_tun();
			kyokumei(khz_no);
			lcd_xy(9,0);
			lcd_khz(khz_no*9);
			adj=0;
		}
		if((up_key==0)&(up_rep==1)){
			up_cnt++;
			if(up_cnt>=30){
				khz_inc_10();
				khz_set();
				khz_set_tun();
				kyokumei(khz_no);
				lcd_xy(9,0);
				lcd_khz(khz_no*9);
				up_cnt=0;
			}
			adj=0;
		}
		/*------------------*/
		if((down_key==0)&(down_rep==0)){
			down_rep=1;
			khz_dec();
			khz_set();
			khz_set_tun();
			kyokumei(khz_no);
			lcd_xy(9,0);
			lcd_khz(khz_no*9);
			adj=0;
		}
		if((down_key==0)&(down_rep==1)){
			down_cnt++;
			if(down_cnt>=30){
				khz_dec_10();
				khz_set();
				khz_set_tun();
				kyokumei(khz_no);
				lcd_xy(9,0);
				lcd_khz(khz_no*9);
				down_cnt=0;
			}
			adj=0;
		}
		/*------------------*/



		/*--------------------*/
		if((set_key==0)&(set_rep==0)){
			set_rep=1;
			preset_up();
			khz_no=preset_khz(preset_no);
			khz_set();
			khz_set_tun();
			kyokumei(khz_no);
			lcd_xy(9,0);
			lcd_khz(khz_no*9);
			adj=0;
		}
		/*--------------------*/
		if((menu_key==0)&(menu_rep==0)){
			menu_rep=1;
			preset_down();
			khz_no=preset_khz(preset_no);
			khz_set();
			khz_set_tun();
			kyokumei(khz_no);
			lcd_xy(9,0);
			lcd_khz(khz_no*9);
			adj=0;
		}
		/*------------------*/




	}
	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */


